#include<string>
#include "theora/theora.h"

using namespace std;

class TheoraMovie
{
public:
	TheoraMovie();
	~TheoraMovie();

	bool Open(const string &filename);
	void NextFrame();
	char *GetData() { return m_Data; }
	unsigned int GetWidth() { return ti.width; }
	unsigned int GetHeight() { return ti.height; }

private:

	void Clear();
	void GetVideoData();
	int BufferData(FILE *in,ogg_sync_state *oy);

	ogg_sync_state   oy;
	ogg_page         og;
	ogg_stream_state vo;
	ogg_stream_state to;
	theora_info      ti;
	theora_comment   tc;
	theora_state     td;
  	ogg_packet op;

	int theora_p;	
	char *m_Data;
	size_t m_StartPos;
	FILE *m_File;

};
